import { Node, Program, Property } from 'estel-estree-builder/generated/es2015';
export interface IReactComponent {
    componentName: string;
    definition: Node;
    props: IReactProperty[];
}
export interface IReactProperty {
    default: any;
    name: string;
    optional: boolean;
    type: string;
}
export declare type ParseResult = Program | undefined;
export interface ICachedSourceFile {
    ast: ParseResult;
    component?: IReactComponent;
    content: string;
    fileName: string;
    filePath: string;
}
export declare const extractProp: (propNode: Property) => IReactProperty;
export declare class SourceFileCache {
    private data;
    constructor();
    getFile(filePath: string): Promise<ICachedSourceFile>;
    fileNames(): string[];
    cachedFiles(): Array<Promise<ICachedSourceFile>>;
    refresh(filePath: string): void;
    clear(filePath: string): void;
}
